// FILE. . . . . /home/hak/hlt/src/hlt/osfv2/base/ButnotSortExpression.java
// EDIT BY . . . Hassan Ait-Kaci
// ON MACHINE. . Hak-Laptop
// STARTED ON. . Mon Sep 02 09:12:55 2013

/**
 * @version     Last modified on Tue Jan 21 08:05:39 2014 by hak
 * @author      <a href="mailto:hak@acm.org">Hassan A&iuml;t-Kaci</a>
 * @copyright   &copy; <a href="http://www.hassan-ait-kaci.net/">by the author</a>
 */

package hlt.osf.base;

/**
 * This is the class of a 'butnot' sort expression. It consists of two
 * sort expressions which are its arguments.
 */
public class ButnotSortExpression extends BinarySortExpression
  {
    public ButnotSortExpression (SortExpression lhs, SortExpression rhs)
    {
      super(lhs,rhs);
      _context = lhs.context();
    }

    public byte type ()
    {
      return _context.BNT();
    }

    public String displayForm ()
    {
      String form = _lhs.displayForm() + " \\ " + _rhs.displayForm();
      return isParenthesized() ? "("+form+")" : form;
    }

    public boolean equals (Object other)
    {
      if (!(other instanceof ButnotSortExpression))
	return false;

      ButnotSortExpression o = (ButnotSortExpression)other;
      
      return _lhs.equals(o.lhs()) && _rhs.equals(o.rhs());
    }
  }
